
#ifndef _EVENT_H
#define _EVENT_H

#include <asm/types.h>
#include "types.h"
#include "object.h"
#include "vs.h"

int event_mask_clear( event_mask_t *e );
int event_mask_setbit( event_mask_t *e, int b );
int event_mask_clrbit( event_mask_t *e, int b );
int event_mask_and( event_mask_t *e, event_mask_t *f );
int event_mask_or( event_mask_t *e, event_mask_t *f );
int event_mask_sub( event_mask_t *e, event_mask_t *f );

struct event_handler_s;
struct event_hadler_hash_s;

struct event_type_s {
	struct event_type_s	*next;
	struct class_s		*op[2];
	struct class_s		*object;
	event_mask_t		mask;
	struct event_type_s	*alt;
	struct event_hadler_hash_s	*handlers_hash;
	struct medusa_optype_s	m;
	struct class_s		operation_class;
};

extern struct event_type_s *global_event_types;
int event_type_add( struct medusa_optype_s *m, struct medusa_attribute_s *a );
int event_type_hash_create( void );
struct event_type_s *event_type_find( u_int16_t classid, u_int16_t opid );
struct event_type_s *event_type_find_name( char *name, struct class_s *s, struct class_s *o, struct class_s *ob );
struct event_type_s *event_type_findset( struct class_s *c );

struct event_context_s;
struct tree_s;

#ifdef DEBUG_TRACE
#define	DT_POS_MAX	64
#else
#define	DT_POS_MAX	0
#endif

struct event_handler_s {
#ifndef DEBUG_TRACE
	char	op_name[MEDUSA_OPNAME_MAX];
#else
	char	op_name[MEDUSA_OPNAME_MAX+DT_POS_MAX];
#endif

	int(*handler)(struct event_handler_s *,struct event_context_s *);
	struct object_s		*local_vars;
	char			data[0];
};
#define	ALL_OBJ	((void*)1)

struct event_hadler_hash_s {
	struct event_hadler_hash_s	*next;
	struct event_handler_s		*handler;
	struct event_type_s		*type;
	vs_t				subject_vs[MAX_VS_BITS/32];
	vs_t				object_vs[MAX_VS_BITS/32];
};

struct event_hadler_hash_s *evhash_add( struct event_hadler_hash_s **hash, struct event_handler_s *handler );
#define	evhash_foreach(ev,hash)	for((ev)=(hash);(ev)!=NULL;(ev)=(ev)->next)

int register_event_handler( struct event_handler_s *h, struct event_type_s *type, vs_t *subject_vs, vs_t *object_vs );

struct event_context_s {
	struct object_s operation;
	struct object_s subject;
	struct object_s object;
	int		result;
	int		first;
	struct object_s	*local_vars;
};

#define	RESULT_UNKNOWN	-1
#define	RESULT_ALLOW	0	/* YES */
#define	RESULT_DENY	1	/* NO */
#define	RESULT_SKIP	2	/* SKIP */
#define	RESULT_OK	3	/* OK */

/*
RESULT_UNKNOWN -> *
RESULT_ALLOW -> RESULT_DENY | RESULT_SKIP
RESULT_DENY -> -
RESULT_SKIP -> RESULT_DENY
RESULT_OK -> RESULT_ALLOW | RESULT_DENY | RESULT_SKIP
*/
int evaluate_result( int old, int new );
int do_event( void *data );

#endif /* _EVENT_H */

