
#include "../constable.h"
#include "../comm0/comm.h"	/* !!!! pozor !!!! */
#include "../language/language.h"
#include "../language/variables.h"
#include "../language/execute.h"
#include <unistd.h>
#include <string.h>
#include <signal.h>

#include "linker.h"

#define	AV_MAX	256

struct fcs_s {
	struct fcs_s *next;
	char *name;
	struct fctab_s *code;
};

static struct fcs_s *fcs_tab = NULL;

u_int32_t load_force_code(char *file)
{
	struct fcs_s *p;
	for (p = fcs_tab; p != NULL; p = p->next) {
		if (p->name == file)
			return (u_int32_t) p;
	}
	if ((p = malloc(sizeof(struct fcs_s))) == NULL)
	{	error(Out_of_memory);
		return 0;
	}
	if ((p->code = object_to_string(file)) == NULL) {
		error("Format of file \"%s\" is inalid.",file);
		free(p);
		return 0;
	}
	p->name = file;
	p->next = fcs_tab;
	fcs_tab = p;
	return (u_int32_t) p;
}

#include "dloader.c"

int force_do( u_int32_t fc, struct event_context_s *c, int(*getarg)(struct register_s*) )
{
	u_int32_t av[AV_MAX];
	int ac, i, l;
	struct register_s r;
	struct medusa_attribute_s *attr;
	struct fcs_s *p = (struct fcs_s *) fc;
	struct medusa_packet msg;
	if (p == NULL)
	{	runtime("Invalid force code");
		return 0;
	}
	ac = 0;
	while( ac<AV_MAX && getarg(&r) )
	{	
		switch( r.attr->type & 0x0f )
		{	case MED_TYPE_UNSIGNED:
			case MED_TYPE_SIGNED:
				for(i=0,l=r.attr->length;l>0;l-=4,i++)
					av[ac++] = ((u_int32_t*)(r.data))[i];
				break;
			case MED_TYPE_STRING:
			default:
				runtime("Unsupported force parameter type %x",r.attr->type);
				break;
		}
	}
	l = sizeof(dloader) + p->code->total_len + ac * 4;
	{
		char buf[l];
		memcpy(buf, dloader, sizeof(dloader));
		memcpy(buf + sizeof(dloader), p->code, p->code->total_len);
		((struct fctab_s *) (buf + sizeof(dloader)))->argc =
		    (u32) ac;
		memcpy(buf + sizeof(dloader) + p->code->total_len,
		       av, ac * 4);
		msg.cmd = MED_FORCE;

		if( (attr=get_attribute(c->subject.class,"pid"))!=NULL )
		{
			msg.u.r_cmd.proc.pid = *((u_int32_t*)(c->subject.data+attr->offset));
			msg.data_len = l;
			comm_cmd(&msg, buf);
		}
		else	runtime("Subject has no pid!");
	}
	return 1;
}



int force_init(void)
{
	return 0;
}
