
#include "execute.h"
#include "language.h"
#include "../constable.h"
#include <unistd.h>

static int cmd_constable_pid( struct event_context_s *c, int(*getarg)(struct register_s*) )
{
	return( (int)getpid() );
}

static int cmd_log( struct event_context_s *c, int(*getarg)(struct register_s*) )
{ char buf[4096];
  int i=0,j;
  struct register_s r;
	while( i<=4000 && getarg(&r) )
	{	if( i>0 )	buf[i++]=' ';
		switch( r.attr->type & 0x0f )
		{	case MED_TYPE_UNSIGNED:
				if( r.attr->length<=4 )
				{	sprintf(buf+i,"%u",
						*((u_int32_t*)(r.data)) );
					i+=strlen(buf+i);
				}
				else
				{	sprintf(buf+i,"%Lu",
						*((u_int64_t*)(r.data)) );
					i+=strlen(buf+i);
				}
				break;
			case MED_TYPE_SIGNED:
				if( r.attr->length<=4 )
				{	sprintf(buf+i,"%d",
						*((u_int32_t*)(r.data)) );
					i+=strlen(buf+i);
				}
				else
				{	sprintf(buf+i,"%Ld",
						*((u_int64_t*)(r.data)) );
					i+=strlen(buf+i);
				}
				break;
			case MED_TYPE_STRING:
				strncpy(buf+i,r.data,MIN(r.attr->length,4095-i));
				buf[i+MIN(r.attr->length,4095-i)]=0;
				i+=strlen(buf+i);
				break;
			case MED_TYPE_BITMAP:
				for(j=0;j<r.attr->length;j+=4)
				{	if(j>0) buf[i++]=':';
					sprintf(buf+i,"%08x",
						((u_int32_t*)(r.data))[j>>2]);
					i+=8;
					if( i>4080 )	break;
				}
				break;
			default:
				sprintf(buf+i,"???");
				i+=strlen(buf+i);
				break;
		}
	}
	buf[i]=0;
	medusa_printlog("log: %s",buf);
	return(0);
}

int cmds_init( void )
{
	lex_addkeyword("constable_pid",Tbuildin,(unsigned long)cmd_constable_pid);
	lex_addkeyword("log",Tbuildin,(unsigned long)cmd_log);
	return(0);
}


