
#include "language.h"
#include "execute.h"
#include "../constable.h"
#include "../event.h"
#include "../tree.h"
#include "../space.h"

u_int32_t load_force_code(char *file);
struct event_handler_s *function_init=NULL;

#define	STARGET	N|0x0a01
#define	STARGET2	N|0x0a02
#define	STARGET3	N|0x0a03
#define	STARGET4	N|0x0a04
#define	S2	N|0x0a08
#define	SOBJ	N|0x0a09
#define	S3	N|0x0a0a
#define	SA	N|0x0a0b
#define	SGT	N|0x0a0c

#define	Pspace		PO|0x0a00
#define	Ppspace		PO|0x0a01
#define	Paddpath	PO|0x0a02
#define	Paddrpath	PO|0x0a03
#define	Psubpath	PO|0x0a04
#define	Psubrpath	PO|0x0a05
#define	Pfindspace	PO|0x0a06
#define	Psubject	PO|0x0a07
#define	Pobject		PO|0x0a08
#define	Poperation	PO|0x0a09
#define	Preg		PO|0x0a0a
#define	Paccess		PO|0x0a0b
#define	Paddvs		PO|0x0a0c
#define	Pallspaces	PO|0x0a0d
#define	Pfunction	PO|0x0a0e
#define	Pfuncend	PO|0x0a0f

/*

	function <meno> { <cmd> ... }

	[primary] space <meno> [recursive] "cesta" , [-] [recursive] "cesta" ... ;

	<space> <op> [<space>] { <cmd> ... }

	<space> <acces_type> <space> , [<acces_type>] <space> ... ;

 */

struct compile_tab_s conf_lang[]={
//	{stav,{terminaly,END},{stack,END}},
	{START,{Tfunction,END},{Tfunction,T_id,Pfunction,T|'{',CMDS,T|'}',Pfuncend,START,END}},
	{START,{Tprimary,END},{Tprimary,Tspace,T_id,Ppspace,STARGET4,START,END}},
	{START,{Tspace,END},{Tspace,T_id,Pspace,STARGET4,START,END}},
	{START,{TEND,END},{END}},
	{STARGET4,{T|';',END},{T|';',END}},
	{STARGET4,{END},{STARGET,END}},
	{STARGET,{Trecursive,END},{Trecursive,T_str,Paddrpath,STARGET2,END}},
	{STARGET,{T_str,END},{T_str,Paddpath,STARGET2,END}},

	{STARGET,{T|'-',END},{T|'-',STARGET3,END}},
	{STARGET3,{Trecursive,END},{Trecursive,T_str,Psubrpath,STARGET2,END}},
	{STARGET3,{T_str,END},{T_str,Psubpath,STARGET2,END}},

	{STARGET2,{T|',',END},{T|',',STARGET,END}},
	{STARGET2,{T|'+',END},{T|'+',STARGET,END}},
	{STARGET2,{T|'-',END},{T|'-',STARGET3,END}},
	{STARGET2,{END},{T|';',END}},

	{START,{T_id,T_str,Trecursive,END},{SGT,Psubject,S2,START,END}},
	{START,{T|'*',END},{T|'*',Pallspaces,Psubject,S2,START,END}},

	{SGT,{T_id,END},{T_id,Pfindspace,END}},
	{SGT,{T_str,END},{VAL|0,Pspace,T_str,Paddpath,END}},
	{SGT,{Trecursive,END},{Trecursive,VAL|0,Pspace,T_str,Paddrpath,END}},
	
	{S2,{T_id,END},{T_id,Poperation,SOBJ,END}},
	{SOBJ,{T|'{',END},{T|'{',CMDS,T|'}',Preg,END}},
	{SOBJ,{T|'*',END},{T|'*',Pallspaces,Pobject,T|'{',CMDS,T|'}',Preg,END}},
	{SOBJ,{END},{SGT,Pobject,T|'{',CMDS,T|'}',Preg,END}},
	{S2,{Taccess,END},{SA,END}},
	{SA,{Taccess,END},{Taccess,Paccess,SGT,Pobject,Paddvs,S3,END}},
	{SA,{END},{SGT,Pobject,Paddvs,S3,END}},
	{S3,{T|',',END},{T|',',SA,END}},
	{S3,{END},{T|';',END}},
	{SRET0,{END},{oLDI,VAL|RESULT_OK,OUT_VAL,oLTI,END}},
	{END}
};

static struct event_handler_s *handler=NULL;
static int handler_size=0;
static int handler_pos=0;

void canf_lang_out( struct compiler_out_class *o, sym_t s, unsigned long d )
{
	if( s == TEND )
		return;
	if( handler==NULL )
		fatal("canf_lang_out");
	if( handler_pos >= handler_size )
	{	handler_size= handler_pos + 8;
		if( (handler=realloc(handler,sizeof(struct event_handler_s)+handler_size*4))==NULL )
			error(Out_of_memory);
	}
	if( (s & TYP) == O )
		d=s;
	((u_int32_t *)(handler->data))[handler_pos++]= d;
}

static void out_destroy( struct compiler_out_class *this )
{	return;
}

struct compiler_out_class s_canf_lang_out={
	out_destroy,
	0,
	canf_lang_out
};

struct class_s *class_of_space( struct space_s *space )
{
	if( space==NULL )
		return(NULL);
	if( space->ltree==NULL )
		return(NULL);
	if( space->ltree->tree==NULL )
		return(NULL);
	/* podla prvej cesty odhadnem class celeho spaceu... !!! nic moc. */
	return(space->ltree->tree->type->obj_class);
}

void canf_lang_param_out( struct compiler_class *c, sym_t s )
{ static struct space_s *space=NULL;
  static struct space_s *space1=NULL;
  static struct space_s *space2=NULL;
  static char *op_name=NULL;
  static int access_type=0;
  vs_t *v;
	switch( s )
	{
		case Pspace:	if( c->l.data != 0 )
				{	space=space_find((char*)(c->l.data));
					if( space!=NULL && space->ltree==NULL && space->ltree_exclude==NULL && !(space->primary) )
						break;
				}
				space=space_create((char*)(c->l.data),0);
				if( space==NULL )
					error("space %s: %s",(char*)(c->l.data),errstr);
				break;
		case Ppspace:	if( c->l.data != 0 )
				{	space=space_find((char*)(c->l.data));
					if( space!=NULL && space->ltree==NULL && space->ltree_exclude==NULL && (space->primary) )
						break;
				}
				space=space_create((char*)(c->l.data),1);
				if( space==NULL )
					error("space %s: %s",(char*)(c->l.data),errstr);
				break;
		case Paddpath:
				if( space_add_path(space,0,create_path((char*)(c->l.data)))<0 )
					error("path %s: %s",(char*)(c->l.data),errstr);
				break;
		case Paddrpath:
				if( space_add_path(space,1,create_path((char*)(c->l.data)))<0 )
					error("path %s: %s",(char*)(c->l.data),errstr);
				break;
		case Psubpath:
				if( space_add_exclude(space,0,create_path((char*)(c->l.data)))<0 )
					error("path %s: %s",(char*)(c->l.data),errstr);
				break;
		case Psubrpath:
				if( space_add_exclude(space,1,create_path((char*)(c->l.data)))<0 )
					error("path %s: %s",(char*)(c->l.data),errstr);
				break;
		case Pfindspace:
				if( (space=space_find((char*)(c->l.data)))==NULL )
					error("Undeclared space %s",(char*)(c->l.data));
				if( space->ltree==NULL )
					error("Undefined space %s",(char*)(c->l.data));
				break;
		case Pallspaces:
				space=ALL_OBJ;
		case Psubject:
				space1=space;
				space2=NULL;
				break;
		case Pobject:
				space2=space;
				break;
		case Poperation:
				handler_size=8;
				handler_pos=0;
				if( (handler=malloc(sizeof(struct event_handler_s)+handler_size*4))==NULL )
					error(Out_of_memory);
				op_name=strdup((char*)(c->l.data));
				handler->op_name[0]=0;
#ifdef DEBUG_TRACE
				snprintf(handler->op_name+MEDUSA_OPNAME_MAX,DT_POS_MAX,"%s:%d",c->lex->filename,c->lex->row);
#endif
				handler->handler=execute_handler;
				handler->local_vars=NULL; /* !!! zatial */
				break;
		case Pfunction:
				handler_size=8;
				handler_pos=0;
				if( (handler=malloc(sizeof(struct event_handler_s)+handler_size*4))==NULL )
					error(Out_of_memory);
				op_name=strdup((char*)(c->l.data));
				handler->op_name[0]=0;
#ifdef DEBUG_TRACE
				snprintf(handler->op_name+MEDUSA_OPNAME_MAX,DT_POS_MAX,"%s:%d",c->lex->filename,c->lex->row);
#endif
				handler->handler=execute_handler;
				handler->local_vars=NULL; /* !!! zatial */
				break;
		case Pfuncend:
				if( !strcmp(op_name,"init") )
					function_init=handler;
				else
					lex_addkeyword(op_name,Tcallfunc,((unsigned long)handler)+((unsigned long)(((struct event_handler_s*)0)->data)));
				handler=NULL;
				break;
		case Preg:
				strncpy(handler->op_name,op_name,MEDUSA_OPNAME_MAX);
//printf("ZZZreg: %s ",handler->type->m.name);
//if( handler->type->op[0] )
//printf("s=%s ",handler->type->op[0]->m.name);
//if( handler->type->op[1] )
//printf("o=%s ",handler->type->op[1]->m.name);
//printf("\n");
				free(op_name); op_name=NULL;
				if( space_add_event(handler,space1,space2)<0 )
					error("Can't register handler - Unknown operation %s",handler->op_name);
				handler=NULL;
//printf("ZZZreg: end\n");
				break;
		case Paccess:
				access_type=c->l.data;
				break;
		case Paddvs:
//printf("ZZZ Paddvs %s <%d- %s\n",space1->name,access_type,space2->name);
				if( (v=space_get_vs(space2))==NULL )
					error("%s",errstr);
//printf("ZZZ Paddvs vs=0x%08x\n",*v);
				if( space_add_vs(space1,access_type,v)<0 )
					error("Can't add vs");
				break;
		case Pforce:
				if( (c->l.data=load_force_code((char*)c->l.data))==0 )
					error("Can't load force code from %s",
						(char*)c->l.data);
				break;
	}

}


compiler_class_t *global_compiler;

static struct compiler_preprocessor_class *prep;

int language_init( char *filename )
{
	if( (global_compiler=compiler_create())==NULL )
		return(init_error("Can't initialize compiler"));
	if( (prep=nul_preprocessor_create(filename))==NULL )
	{	global_compiler->destroy(global_compiler);
		return(init_error("Can't open file %s",filename));
	}
	inc_use(prep);
	if( (global_compiler->lex=lex_create(lex_tab,prep))==NULL )
	{	global_compiler->destroy(global_compiler);
		dec_use(prep);
		return(init_error("Can't initialize lexical analyzer"));
	}
	global_compiler->out=&s_canf_lang_out;
	global_compiler->err=&s_error;
	global_compiler->param_out=canf_lang_param_out;
	global_compiler->add_table(global_compiler,conf_lang);
	global_compiler->add_table(global_compiler,language);
	global_compiler->add_table(global_compiler,value);
	global_compiler->add_table(global_compiler,expression);
	return(0);
}

int language_do( void )
{
	lex_addkeyword("NULL",T_str,0);
	global_compiler->compile(global_compiler,START);
	if( global_compiler->err->errors > 0 || global_compiler->err->warnings > 0 )
		fprintf(stderr,"Errors: %d\nWarnings: %d\n",global_compiler->err->errors,global_compiler->err->warnings);
	if( global_compiler->err->errors > 0 )
	{ 	global_compiler->destroy(global_compiler);
		dec_use(prep);
		return(-1);
	}
	global_compiler->destroy(global_compiler);
	dec_use(prep);
	return(0);
}

