
#include "language.h"
#include "variables.h"
#include "../constable.h"
#include "../types.h"
#include "../event.h"

#define	SV1a	N|0x0d01
#define	SV2	N|0x0d02
#define	SV3	N|0x0d03
#define	SV4	N|0x0d04
#define	SV5	N|0x0d05
#define	SS1	N|0x0d10

struct compile_tab_s value[]={
	{S_val,{T_num,END},{oLDI,T_num,OUT_VAL,oLTI,END}},
	{S_val,{T_arg,END},{oARG,T_arg,OUT_VAL,END}},
	{S_val,{T_str,END},{T_str,SS1,END}},
	{SS1,{T|'(',END},{SEC_START|4,Pforce,SEC_SETVAL|1,SV2,oFRC,OUT_VAL4|1,OUT_VAL4|0,oDEn,OUT_VAL4|0,SEC_END,END}},
	{SS1,{END},{oLDI,OUT_VAL,oLTS,END}},
	{S_val,{Tspace,END},{Tspace,oLDC,OUT_LEX,T_id,OUT_VAL,END}},
	{S_val,{T_id,END},{T_id,SV1a,END}},
	{SV1a,{T|'.',END},{oLDS,OUT_VAL,T|'.',T_id,OUT_VAL,END}},
	{SV1a,{END},{oLDV,OUT_VAL,END}},
/* buildin command */
	{S_val,{Tbuildin,END},{SEC_START|4,Tbuildin,SEC_SETVAL|1,SV2,oBIN,OUT_VAL4|1,OUT_VAL4|0,oDEn,OUT_VAL4|0,SEC_END,END}},
	{S_val,{Tcallfunc,END},{SEC_START|4,Tcallfunc,SEC_SETVAL|1,SV2,oJSR,OUT_VAL4|1,oDEn,OUT_VAL4|0,SEC_END,END}},
	{S_val,{Tprocess,END},{SEC_START|4,Tprocess,S_exp,oPRO,OUT_VAL4|1,oJR,OUT_VAL4|2,SEC_SETPOS|1,END}},
	{NEXTLINE,{},{         SEC_START|3,SEC_START|2,CMD,SEC_END,SEC_END,SRET0,oRET,SEC_SETPOS|2,SEC_END,END}},
	{SV2,{T|';',END},{SEC_INCVAL|0,SEC_DECVAL|0,END}},
	{SV2,{T|',',END},{SEC_INCVAL|0,SEC_DECVAL|0,END}},
	{SV2,{END},{T|'(',SV3,T|')',END}},
	{SV3,{T|')',END},{SEC_INCVAL|0,SEC_DECVAL|0,END}},
	{SV3,{END},{SV5,END}},
	{SV4,{T|',',END},{T|',',SV5,END}},
	{SV4,{END},{END}},
	{SV5,{END},{S_exp,SEC_INCVAL|0,SV4,END}},
	{END}
};

u_int32_t data_load_var( struct event_context_s *c, char *name, char *attr, struct medusa_attribute_s **a )
{ struct object_s *o;
  struct sval_s sv;

	if( attr==NULL )
	{	if( c->operation.class!=NULL
		    && (*a=get_attribute(c->operation.class,name))!=NULL )
			return( (u_int32_t)(c->operation.data) );
		if( c->subject.class!=NULL
		    && (*a=get_attribute(c->subject.class,name))!=NULL )
			return( (u_int32_t)(c->subject.data) );
		if( c->object.class!=NULL
		    && (*a=get_attribute(c->object.class,name))!=NULL )
			return( (u_int32_t)(c->object.data) );
	}
	if( c->operation.class!=NULL
	    && !strncmp(c->operation.attr.name,name,MEDUSA_ATTRNAME_MAX) )
		o=&(c->operation);
	else if( c->subject.class!=NULL
	    && !strncmp(c->subject.attr.name,name,MEDUSA_ATTRNAME_MAX) )
		o=&(c->subject);
	else if( c->object.class!=NULL
	    && !strncmp(c->object.attr.name,name,MEDUSA_ATTRNAME_MAX) )
		o=&(c->object);
	else if( (o=get_var(c->local_vars,name))==NULL )
	{	runtime("Undefined variable %s",name);
		return(0);
	}
	if( var_to_sval(o,attr,&sv)<0 )
	{	runtime("Variable %s has no member %s",name,attr);
		return(0);
	}
	*a = (struct medusa_attribute_s *)(sv.type);
	return( sv.data );
}

