
#ifndef _EXECUTE_H
#define _EXECUTE_H

#include "../event.h"

#define MAX_REG_SIZE	4096

struct register_s {
	struct medusa_attribute_s *attr;
	struct medusa_attribute_s tmp_attr;
	char *data;
	char buf[MAX_REG_SIZE];
};

int r_int( struct register_s *r );
void r_imm( struct register_s *r );
void r_sto( struct register_s *v, struct register_s *d );
void r_resize( struct register_s *v, int size );

int strnlen( char *s, int n );

void r_neg( struct register_s *v );
void r_not( struct register_s *v );
int r_nz( struct register_s *v );

void do_bin_op( int op, struct register_s *v, struct register_s *d );

int load_constant( struct register_s *r , u_int32_t typ, char * name );
u_int32_t data_load_var( struct event_context_s *c, char *name, char *attr, struct medusa_attribute_s **a );

int execute_handler( struct event_handler_s *h, struct event_context_s *c );

#endif /* _EXECUTE_H */

