#ifndef _MEDUSA_OBJECT_H
#define _MEDUSA_OBJECT_H

//#include <medusa/config.h>

#define	MEDUSA_ATTRNAME_MAX	27
#define	MEDUSA_CLASSNAME_MAX	12
#define	MEDUSA_OPNAME_MAX	16

/*
 * Used by l2, l3, l4
 *
 * This file defines
 *		CLASS (defined in l2, used by l3, l4)	medusa_class_s
 *		OBJECT (defined in l2, used by l3, l4)	medusa_object_s
 *		ATTRIBUTE (defined in l2, used by l4)	medusa_attribute_s
 */

/**/
/**/

/* describes one attribute in class (defined in l2 code, used by l4) */
struct medusa_attribute_s {
	u_int16_t offset;		/* offset of attribute in object */
	u_int16_t length;		/* bytes consumed by data */
	u_int8_t type;			/* data type (MED_TYPE_xxx) */
	char name[MEDUSA_ATTRNAME_MAX];	/* string: attribute name */
};

#define	MED_TYPE_END		0x00	/* end of attribute list */
#define	MED_TYPE_UNSIGNED	0x01	/* unsigned integer attr */
#define	MED_TYPE_SIGNED		0x02	/* signed integer attr */
#define	MED_TYPE_STRING		0x03	/* string attr */
#define	MED_TYPE_BITMAP		0x04	/* bitmap attr */

#define	MED_TYPE_READ_ONLY	0x80	/* this attribute is read-only */
#define	MED_TYPE_PRIMARY_KEY	0x40	/* this attribute is used to lookup object */

/**/
/**/

/* description of class (defined in l2 code, used by l3, l4) */
struct medusa_class_s {
	u_int16_t	classid;	/* (1,2,...): unique identifier of this class */
	u_int16_t	size;		/* size of object */
	char		name[MEDUSA_CLASSNAME_MAX];
};

/* description of access/operation type */
struct medusa_optype_s {
	u_int16_t	classid;	/* class, which acts as a subject of this operation  --- !!! subject nieje vhodne slovo. */
	u_int16_t	opid;		/* (1,2,...): unique identifier of access type within class */
	u_int16_t	size;
	char		name[MEDUSA_OPNAME_MAX];
	u_int16_t	op_class[2];
	char		op_name[2][MEDUSA_ATTRNAME_MAX];
};

#endif

