
#ifndef _OBJECT_H
#define _OBJECT_H

#include "types.h"
#include "medusa_object.h"

struct object_s;

struct class_set_s {
	struct class_set_s	*next;
	int(*handler)(struct object_s *);
};

struct class_s {
	struct class_s			*next;
	u_int16_t			cinfo_offset;
	u_int16_t			cinfo_size;	/* v 32 bit slovach */
	u_int32_t			cinfo_mask;
	struct class_set_s		*set;
	u_int16_t			vs_offset;
	u_int16_t			vs_size;	/* v 32 bit slovach */
	u_int16_t			event_offset;
	u_int16_t			event_size;	/* v bajtoch */
	struct medusa_class_s		m;
	struct medusa_attribute_s	attr[0];
};

struct object_s {
	struct object_s *next;
	struct medusa_attribute_s attr;
	struct class_s	*class;
	char	*data;
};

struct class_s *get_class_by_name( char *name );
struct class_s *get_class_by_id( u_int16_t id );
struct medusa_attribute_s *get_attribute( struct class_s *c, char *name );
struct class_s *add_class( struct medusa_class_s *mc, struct medusa_attribute_s *a );
int class_alloc_cinfo( struct class_s *c );
int class_add_sethandler( struct class_s *c, int(*handler)(struct object_s *) );
int object_is_same( struct object_s *a, struct object_s *b );

int object_clear_event( struct object_s *o );
int object_add_event( struct object_s *o, event_mask_t *e );
int object_set_inherit( struct object_s *o );
int object_clr_inherit( struct object_s *o );

int object_do_sethandler( struct object_s *o );

#endif

