
#ifndef _TARGET_H
#define _TARGET_H

#include "tree.h"
#include "event.h"
#include "access_types.h"

/* !!!Najprv definovat cesty a excludes a az potom priradovat vs-ka a eventy.!!! */

extern struct space_s *global_spaces;

typedef struct ltree_s {
	struct ltree_s	*prev;
	struct tree_s	*tree;
	int		recursive;
} ltree_t;

typedef struct levent_s {
	struct levent_s		*prev;
	struct event_handler_s	*handler;
	struct space_s		*subject;
	struct space_s		*object;
} levent_t;

struct space_s {
	struct space_s	*next;
	struct vs_s	*my_vs;
	vs_t		vs[NR_ACCESS_TYPES][MAX_VS_BITS/32];
	levent_t	*levent;
	ltree_t		*ltree;
	ltree_t		*ltree_exclude;
	int		primary;
	char		name[0];
};

struct space_s *space_create( char *name, int primary );
struct space_s *space_find( char *name );
int space_add_path( struct space_s *space, int recursive, struct tree_s *path );
int space_add_exclude( struct space_s *space, int recursive, struct tree_s *path );
int space_add_event( struct event_handler_s *handler, struct space_s *subject, struct space_s *object );
int space_add_vs( struct space_s *space, int which, vs_t *vs );
vs_t *space_get_vs( struct space_s *space );


#endif /* _TARGET_H */

