
#ifndef _TREE_H
#define _TREE_H

#include "vs.h"
#include "event.h"

struct tree_s;
struct space_s;

struct tree_type_s {
	char	*name;
	int	size;		/* size of node */
	struct class_s	*obj_class;	/* pre eventy */
	int(*init)(struct tree_s*);
	struct tree_type_s *child_type;
	int(*add_vs)(struct tree_s*,int recursive,int which,const vs_t *vs);
};

struct tree_s {
	struct tree_s	*parent;
	struct tree_s	*child;		/* normalny potomkovia */
	struct tree_s	*reg;		/* potomkovia s regexpami */
	struct tree_s	*next;
	struct tree_s	*alt;		/* alternative */
	struct tree_type_s *type;
	char		*name;
	void		*extra;		/* precompiled regexp... */
	struct space_s	*primary_space;
	struct space_s	*recursive_primary_space;
	event_mask_t	event;
	event_mask_t	recursive_event;
};

typedef struct tree_type_s tree_type_t;

extern struct tree_s global_root;

int register_tree_type( tree_type_t *type );
struct tree_s *create_path( char *path );
struct tree_s *find_one( struct tree_s *base, char *name );
int tree_is_offspring( struct tree_s *offspring, struct tree_s *ancestor );

//int path_add_vs( char *path, int recursive, int which, const vs_t *vs );

char *tree_get_path( struct tree_s *t );

#endif

